package cn.ibizlab.assetmanagement.core.workorder.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.assetmanagement.core.workorder.domain.EAMWorkOrder;
import cn.ibizlab.assetmanagement.core.workorder.filter.EAMWorkOrderSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EAMWorkOrder] 服务对象接口
 */
public interface IEAMWorkOrderService extends IService<EAMWorkOrder>{

    boolean create(EAMWorkOrder et) ;
    void createBatch(List<EAMWorkOrder> list) ;
    boolean update(EAMWorkOrder et) ;
    void updateBatch(List<EAMWorkOrder> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    EAMWorkOrder get(String key) ;
    EAMWorkOrder getDraft(EAMWorkOrder et) ;
    boolean checkKey(EAMWorkOrder et) ;
    boolean save(EAMWorkOrder et) ;
    void saveBatch(List<EAMWorkOrder> list) ;
    Page<EAMWorkOrder> searchDefault(EAMWorkOrderSearchContext context) ;
    List<EAMWorkOrder> selectByAssetid(String assetid) ;
    void removeByAssetid(String assetid) ;
    List<EAMWorkOrder> selectByEamlocationid(String eamlocationid) ;
    void removeByEamlocationid(String eamlocationid) ;
    List<EAMWorkOrder> selectByPworkorderid(String workorderid) ;
    void removeByPworkorderid(String workorderid) ;
    List<EAMWorkOrder> selectByEamwotypeid(String eamwotypeid) ;
    void removeByEamwotypeid(String eamwotypeid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<EAMWorkOrder> getEamworkorderByIds(List<String> ids) ;
    List<EAMWorkOrder> getEamworkorderByEntities(List<EAMWorkOrder> entities) ;
}


